#ifndef LUA_HPP
#define LUA_HPP LuaTarget
using namespace StandardComponents;

struct LuaTarget: Target {
    print_functions_pair printFunctions() final { return make_pair("io.write", "print"); }
    optional_string uniqueLineSeparator() final { return " "; }
    unordered_task_map getTaskMap() final {
        return {
            make_task(Define,
                if (parseComponent.final) output << "local ";
                output << parseComponent.name;
                if (parseComponent.final) output << " <const>"; // TODO Find an alternative to <const> for lua <5.4
                output << " = ";
            ),
            make_task(types::String, stringInterpolation(parseComponent.content, "[[", "]]", "..");)
        };
    }
    using Target::Target;
};

#endif